rm(list=ls(all=TRUE))  # clean up left overs from previous run, though shouldn't need to.
if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
#source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
setwd(home)  # place where models and results will go
library(PolynomF)
library(snow)
library(DEoptim)
library(rgenoud)  
library(numDeriv)
#library(genalg)  
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
load(paste(home,"/results/G0.RData",sep=""))
ID=sapply(G,function(x) x$id)
SSE=sapply(G,function(x) x$SSE$final)
leadL=sapply(G,function(x) x$lead)
doneL=sapply(G,function(x) x$done)
leads=ID[leadL]
deck=ID[!doneL]
done=ID[doneL]
for (i in done) G[[i]]$lead=FALSE  # those done coming in are no longer leads coming out
cat("Number of leads = ",length(leads)," Number left in deck = ",length(deck),"  Number done = ",length(done),"\n")
GN=NULL
for (i in leads) {
  draw=getNeighbors(i,deck)
  GN=c(GN,setGICs(G,draw,i))
}
cat("The number of models fitted in this round is ",length(GN),"\n")
t0 = Sys.time();      
GN=runClust(GN,method="optim")
#GN=lapply(GN,fitModel,method="optim")

# clean up and condense
SSEN=sapply(GN,function(x) x$SSE$final)
IDN=sapply(GN,function(x) x$id)
(mins=tapply(SSEN,IDN,min))
nG=GN[nms<-names(mins)]  # should take first occurence of index
for (i in nms) {
  if (nG[[i]]$SSE$final > mins[i]) {
    nG[i] = GN[which((SSEN==mins[i])&(IDN==i))[1]]
  } 
}
G[nms]=nG[nms]  # update if out of deck also
SSEn=sapply(nG,function(x) x$SSE$final)
IDn=sapply(nG,function(x) x$id)
leads=IDn[SSEn<=3*min(SSE)] 
done=union(done,leads);
deck=setdiff(ID,done)
for (i in done) G[[i]]$done=TRUE
for (i in leads) G[[i]]$lead=TRUE
save(G,file=paste(home,"/results/G1.RData",sep=""))
difftime(Sys.time(),t0,units="mins")
