getEkZ1<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dk)[1]
  attach(Pframe)
  attach(g$dk)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-RT[j], 1,0,0,0,0,6*( (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z3=R^6*X^i3/K3^(i3+5)
    RQ=R+6*Z3
    if (length(R)==1) {
      g$dk$RQ[j]=RQ
      g$dk$Ek[j]=(6*k3*Z3)/RT[j]
      g$dk$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dk$Ek[j]=1}
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      g$dk$Ek[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(Pframe)
  detach(g$dk)
  SSE=sum((g$dk$Ek-g$dk$k)^2)
  P=sum(g$params[,"opt"]) + 1 # include the variance
  aic=N*log(SSE/N)+2*P + 2*P*(P+1)/(N-P-1) + N*log(2*pi) + N
  if (P>=N-1) aic=Inf
  if (init) {
    g$SSE$initial=SSE 
    g$AIC$initial = aic
    g$params[,"initial"] = g$params[,"final"]
  } 
  g$SSE$final=SSE 
  g$AIC$final =  aic
  g
}

getEkZMM<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dk)[1]
  attach(Pframe)
  attach(g$dk)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-RT[j], 1,0,0,0,0,6*(1+X/K3)^i3/KR^5)  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z3=R^6*(1+X/K3)^i3/KR^5
    RQ=R+6*Z3
    if (length(R)==1) {
      g$dk$RQ[j]=RQ
      g$dk$Ek[j]=(6*k3*Z3)/RT[j]
      g$dk$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dk$Ek[j]=1}
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      g$dk$Ek[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(Pframe)
  detach(g$dk)
  SSE=sum((g$dk$Ek-g$dk$k)^2)
  P=sum(g$params[,"opt"]) + 1 # include the variance
  aic=N*log(SSE/N)+2*P + 2*P*(P+1)/(N-P-1) + N*log(2*pi) + N
  if (P>=N-1) aic=Inf
  if (init) {
    g$SSE$initial=SSE 
    g$AIC$initial = aic
    g$params[,"initial"] = g$params[,"final"]
  } 
  g$SSE$final=SSE 
  g$AIC$final =  aic
  g
}




getEkZ2<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dk)[1]
  attach(Pframe)
  attach(g$dk)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-RT[j], 1,2*(X/K1)^i1/K1,0,0,0,6*( (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z1=R^2*X^i1/K1^(i1+1)
    Z3=R^6*X^i3/K3^(i3+5)
    RQ=R+2*Z1+6*Z3
    if (length(R)==1) {
      g$dk$RQ[j]=RQ
      g$dk$Ek[j]=(2*k1*Z1+6*k3*Z3)/RT[j]
      g$dk$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dk$Ek[j]=1}
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"k3 = ",k3,"K3 = ",K3,"\n")
      g$dk$Ek[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(Pframe)
  detach(g$dk)
  SSE=sum((g$dk$Ek-g$dk$k)^2)
  P=sum(g$params[,"opt"]) + 1 # include the variance
  aic=N*log(SSE/N)+2*P + 2*P*(P+1)/(N-P-1) + N*log(2*pi) + N
  if (P>=N-1) aic=Inf
  if (init) {
    g$SSE$initial=SSE 
    g$AIC$initial = aic
    g$params[,"initial"] = g$params[,"final"]
  } 
  g$SSE$final=SSE 
  g$AIC$final =  aic
  g
}



fitModel1 <- function(g) {
  
  fopt <- function(pars,model) {  # do not relabel model as g
    pars=exp(pars)
    model$params[names(pars),"final"]=pars  
    model=getEkZ1(model)
    return(model$SSE$final)   
  }
  
  p0=t(g$params[g$params[,"opt"],"initial",drop=F])
  p0=unlist(as.data.frame(p0))
  p0=sapply(p0,log)
  g$optNames<-names(p0)
#  print(p0)
  if ((g$nOptParams<-n<-length(p0))>0) { 
    if (g$nOptParams>1) opt<-optim(p0,fopt,hessian=TRUE,model=g,control=list(trace=F,maxit=5000)) else
      opt<-optim(p0,fopt,method="BFGS",hessian=TRUE,model=g,control=list(trace=F));       
    opar<-opt$par
    Hess=opt$hessian
    value=opt$value
    print(value)# =   print(fopt(opar,g))
    eopar=exp(opar)  
    g$params[g$optNames,"final"]=eopar  
    g$Hess=Hess; 
    sg<-sqrt(value/(g$nData-g$nOptParams))
    if (abs(det(Hess))>1e-8) 
    {sig=sg*sqrt(diag(solve(Hess/2)))
      upper=signif(opar+1.96*sig,3)
      lower=signif(opar-1.96*sig,3)
      CI=cbind(lower,upper)
      CI=exp(CI); 
      g$CI=CI; 
      g$hess=TRUE} else
    {g$hess=FALSE} 
  } else {print("nothing to optimize");  g$params[,"final"]=g$params[,"initial"] }
  g=getEkZ1(g) # give g the latest expected values
  g
}
# end fitModel


fitModel2 <- function(g) {
  
  fopt <- function(pars,model) {  # do not relabel model as g
    pars=exp(pars)
    model$params[names(pars),"final"]=pars  
    model=getEkZ2(model)
    return(model$SSE$final)   
  }
  
  p0=t(g$params[g$params[,"opt"],"initial",drop=F])
  p0=unlist(as.data.frame(p0))
  p0=sapply(p0,log)
  g$optNames<-names(p0)
#  print(p0)
  if ((g$nOptParams<-n<-length(p0))>0) { 
    if (g$nOptParams>1) opt<-optim(p0,fopt,hessian=TRUE,model=g,control=list(trace=F,maxit=5000)) else
      opt<-optim(p0,fopt,method="BFGS",hessian=TRUE,model=g,control=list(trace=F));       
    opar<-opt$par
    Hess=opt$hessian
    value=opt$value
    print(value)# =   print(fopt(opar,g))
    eopar=exp(opar)  
    g$params[g$optNames,"final"]=eopar  
    g$Hess=Hess; 
    sg<-sqrt(value/(g$nData-g$nOptParams))
    if (abs(det(Hess))>1e-8) 
    {sig=sg*sqrt(diag(solve(Hess/2)))
      upper=signif(opar+1.96*sig,3)
      lower=signif(opar-1.96*sig,3)
      CI=cbind(lower,upper)
      CI=exp(CI); 
      g$CI=CI; 
      g$hess=TRUE} else
    {g$hess=FALSE} 
  } else {print("nothing to optimize");  g$params[,"final"]=g$params[,"initial"] }
  g=getEkZ2(g) # give g the latest expected values
  g
}
# end fitModel



fitModelMM <- function(g) {
  
  fopt <- function(pars,model) {  # do not relabel model as g
    pars=exp(pars)
    model$params[names(pars),"final"]=pars  
    model=getEkZMM(model)
    return(model$SSE$final)   
  }
  
  p0=t(g$params[g$params[,"opt"],"initial",drop=F])
  p0=unlist(as.data.frame(p0))
  p0=sapply(p0,log)
  g$optNames<-names(p0)
#  print(p0)
  if ((g$nOptParams<-n<-length(p0))>0) { 
    if (g$nOptParams>1) opt<-optim(p0,fopt,hessian=TRUE,model=g,control=list(trace=F,maxit=5000)) else
      opt<-optim(p0,fopt,method="BFGS",hessian=TRUE,model=g,control=list(trace=F));       
    opar<-opt$par
    Hess=opt$hessian
    value=opt$value
    print(value)# =   print(fopt(opar,g))
    eopar=exp(opar)  
    g$params[g$optNames,"final"]=eopar  
    g$Hess=Hess; 
    sg<-sqrt(value/(g$nData-g$nOptParams))
    if (abs(det(Hess))>1e-8) 
    {sig=sg*sqrt(diag(solve(Hess/2)))
      upper=signif(opar+1.96*sig,3)
      lower=signif(opar-1.96*sig,3)
      CI=cbind(lower,upper)
      CI=exp(CI); 
      g$CI=CI; 
      g$hess=TRUE} else
    {g$hess=FALSE} 
  } else {print("nothing to optimize");  g$params[,"final"]=g$params[,"initial"] }
  g=getEkZ1(g) # give g the latest expected values
  g
}
# end fitModel



initGZ2<-function(dk) {
  g=NULL
  g$dk=dk
  cnt=0
  G=NULL
  for (j1 in 1:5) 
    for (j3 in (3*j1+1):18){
      cnt=cnt+1
      s=c(i1=j1,i3=j3,k1=30,k3=100,K1=5,K3=10)
      g$params=data.frame(initial=s,final=s,opt=TRUE,constr="none")
      g$params[1:2,"opt"]=FALSE
#      g$params[4,"constr"]="k1"
      g$id=paste("GZ",j1,j3,sep=".")
      g=getEkZ1(g,init=TRUE)
      G[[cnt]]=g
    }
  names(G)<-sapply(G,function(x) x$id)
  G
}

initGZ1<-function(dk) {
  g=NULL
  g$dk=dk
  cnt=0
  G=NULL
    for (j3 in 1:18){
      cnt=cnt+1
      s=c(i3=j3,k3=100,K3=10)
      g$params=data.frame(initial=s,final=s,opt=TRUE,constr="none")
      g$params[1,"opt"]=FALSE
      #        g$params[c(5,7),"constr"]="k0"
      g$id=paste("GZ",j3,sep=".")
      g=getEkZ1(g,init=TRUE)
      G[[cnt]]=g
    }
  names(G)<-sapply(G,function(x) x$id)
  G
}

initGZMM<-function(dk) {
  g=NULL
  g$dk=dk
  cnt=0
  G=NULL
  for (j3 in 1:18){
    cnt=cnt+1
    s=c(i3=j3,k3=100,K3=10,KR=100)
    g$params=data.frame(initial=s,final=s,opt=TRUE,constr="none")
    g$params[1,"opt"]=FALSE
    #        g$params[c(5,7),"constr"]="k0"
    g$id=paste("GZ",j3,sep=".")
    g=getEkZ1(g,init=TRUE)
    G[[cnt]]=g
  }
  names(G)<-sapply(G,function(x) x$id)
  G
}


mkpdk1<-function(g){
  pd=data.frame(RT=1.84, XT=c(seq(0,320,by=10),seq(980,1020,by=10)))
  pg=g
  pg$dk=pd
  pg=getEkZ1(pg)
  g$pdk=pg$dk
  g
}

mkpdk2<-function(g){
  pd=data.frame(RT=1.84, XT=c(seq(0,320,by=10),seq(980,1020,by=10)))
  pg=g
  pg$dk=pd
  pg=getEkZ2(pg)
  g$pdk=pg$dk
  g
}

mkpdkMM<-function(g){
  pd=data.frame(RT=1.84, XT=c(seq(0,320,by=10),seq(980,1020,by=10)))
  pg=g
  pg$dk=pd
  pg=getEkZMM(pg)
  g$pdk=pg$dk
  g
}

plotG<-function(G,kill=FALSE){
  library(plotrix)
  if (kill) graphics.off();
  g=G[[1]]
  windows(width = 5, height = 4,restoreConsole = TRUE,ypos=0) 
  par(mfcol=c(1,1),mar=c(4.2,4,0,1)+.1,oma=c(0,0,0,0))
  with(g$dk,plot(XT,k,ylim=c(0,6),xlim=c(0,310),ylab="1/sec",xlab="[ATP] in uM"))
  for (i in 1:4) with(G[[i]]$pdk,lines(XT,Ek,lty=i))
#  title("Single Hexamer Models",outer=TRUE,line=0.7,cex.main=1)
   legend(0,5,lty=1:4,bty="n",c(expression(i[3]==1),expression(i[3]==2),expression(i[3]==3),expression(i[3]==4)))  
}
plotG(G)

plotG2<-function(G,kill=FALSE){
  library(plotrix)
  if (kill) graphics.off();
  g=G[[1]]
  windows(width = 5, height = 4,restoreConsole = TRUE,ypos=0) 
  par(mfcol=c(1,1),mar=c(4.2,4,0,1)+.1,oma=c(0,0,3,1))
  with(g$dk,gap.plot(XT,k,gap=c(340,990),xtics=c(0,100,200,300),
          gap.axis="x",ylim=c(0,85),xlim=c(0,370),ylab="Relative CDP Reductase Activity",xlab="[ATP] in uM"))
  axis(1,at=350,label="1000")
  for (i in 1:8) with(G[[i]]$pdk,lines(XT,Ek,lty=i))
  title("Single Hexamer Models",outer=TRUE,line=0.7,cex.main=1.2)
}



runClust<-function(G,Z=2){
  bigNms=c("localhost")
  rackLen=c(12,12)
  for (rack in 0:1) for (node in 0:rackLen[rack+1])  bigNms=c(bigNms,paste("compute",rack,node,sep="-"))
  big=rep(4,length(bigNms))
  names(big)<-bigNms
  (cpusPerHost=big)
  if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
  source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
  if (host=="tk1") cpusPerHost=cpusPerHost[1]
  if (host=="rnrClust") cpusPerHost=cpusPerHost[1:5]
  if (host=="ATP") cpusPerHost=c("localhost" = 3)
  if (host=="dNTP") cpusPerHost=c("localhost" = 3)
  if (host=="tk2") cpusPerHost=cpusPerHost[c(1:8)]
  cpusPerHost
  cpus=sum(cpusPerHost)
  hosts=names(cpusPerHost)
  print(host)
  print(cpusPerHost)
  strn=rep(hosts,times=cpusPerHost)
  setDefaultClusterOptions(outfile="/tmp/debugR.t")
  cl <- makeCluster(strn, type="SOCK", verbose=TRUE) # this one can work either way
  clusterEvalQ(cl, require(PolynomF))
  clusterEvalQ(cl, require(odesolve))
  clusterExport(cl,ls(.GlobalEnv))
  if (Z==1)  G=clusterApplyLB(cl,G,fitModel1) else
    if (Z==2) G=clusterApplyLB(cl,G,fitModel2) else
      G=clusterApplyLB(cl,G,fitModelMM)
  stopCluster(cl)
  names(G)<-sapply(G,function(x) x$id)
  G
} 


