if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXCutils.R",sep=""))
t0 = Sys.time();      
G=mkG0()
for (i in 1:20) {
  cat("N = ",i,"\n")
  G=mkGN(G,i)
  if (G[[1]]$lenLeads==0) {
    cat("next length(Leads) = 0, breaking at N = ",i,"\n")
    break
  }
}

for (j in 1:length(G)) {
  G[[j]]$params[c(4,8),"opt"]=TRUE
  G[[j]]$params[c(5,7),"constr"]="k0"
  G[[j]]$params[,"initial"]=G[[j]]$params[,"final"]
#  G[[j]]$SSE$initial=G[[j]]$SSE$final  # comment = track initial from whole process
  G[[j]]$best$params=G[[j]]$params
}

G=runClust(G,method="optim")

#for (j in 1:length(G)) {
#  G[[j]]$params[12,"opt"]=TRUE
#  G[[j]]$params[,"initial"]=G[[j]]$params[,"final"]
#  G[[j]]$best$params=G[[j]]$params
#}
#
#G=runClust(G,method="optim")

G=lapply(G,getEm)  # similar for getEk already done in fitModel
G=lapply(G,mkpdk)
G=lapply(G,mkpdm)

save(G,file=paste(home,"/results/G.RData",sep=""))
difftime(Sys.time(),t0,units="mins")

