if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonZ1.R",sep=""))
t0 = Sys.time();      
setwd(home)  # place where models and results will go
library(ccems)
#d=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0)&(X<3200),select=c(R,r,C,X,v,year))
dk=subset(RNR,(year==2010),select=c(R,r,C,X,v,year))
dk=transform(dk,k=v)
names(dk)[c(1,4)]=c("RT","XT")
dim(dk)
dk=dk[order(dk$XT),]
dk
dk=transform(dk,k=(.27*61.83/180)*k)  # 61.83 converts to nmol/mg/min and .27/180 converts to 1/sec

dk=dk[1:(dim(dk)[1]-3),]

options(stringsAsFactors = FALSE)
library(PolynomF)
library(snow)
G=initGZ1(dk)
G

#G=runClust(G)
G=lapply(G,fitModel1)


G=lapply(G,mkpdk1)
save(G,file=paste(home,"/results/GZ1.RData",sep=""))
difftime(Sys.time(),t0,units="mins")
load(paste(home,"/results/GZ1.RData",sep=""))
(SSE=sapply(G,function(x) x$SSE$final))
plotG(G)


load(paste(home,"/results/GZ2.RData",sep=""))
(SSE=sapply(G,function(x) x$SSE$final))
plotG2(G)

load(paste(home,"/results/GZMM.RData",sep=""))
(SSE=sapply(G,function(x) x$SSE$final))
plotG2(G)
